Loading...
Searching...
No Matches
casacore::Directory Class Reference
casa package (libcasa_casa) » OS_module

More...

`#include <Directory.h>`

## Public Member Functions

| Directory ()
| Sets the path on the current working directory.
| Directory (const Path &name)
| Create a directory object for a file with the given path name.
| Directory (const String &name)
| Directory (const File &name)
| Directory (const Directory &that)
| Copy constructor (copy semantics).
| ~Directory ()
Directory & | operator= (const Directory &that)
| Assignment (copy semantics).
Bool | isEmpty () const
| Check if directory is empty.
uInt | nEntries () const
| Return the number of entries in the directory (not counting.
Double | freeSpace () const
| Get the amount of free space (in bytes) on the file system this directory is on.
uInt | freeSpaceInMB () const
void | create (Bool overwrite=True)
| Create the directory.
void | remove ()
| Remove a directory.
void | removeFiles ()
| Remove all files in the directory except subdirectories.
void | removeRecursive (Bool keepDir=False)
| Remove the directory and its contents (recursively in all subdirectories).
void | copy (const Path &target, Bool overwrite=True, Bool setUserWritePermission=True) const
| Copy the directory and its contents (recursively) to the target path using the system command cp -r.
void | copy (const String &target, Bool overwrite=True, Bool setUserWritePermission=True) const
void | copyRecursive (const String &target) const
| Copy a directory recursively in a manual way.
void | move (const Path &target, Bool overwrite=True)
| Move the directory to the target path using the system command mv.
void | move (const String &target, Bool overwrite=True)
Vector< String > | find (const Regex &regexp, Bool followSymLinks=False, Bool recursive=True) const
| Find all files which whose names match regex.
virtual Int64 | size () const
| Return the total size of everything in the Directory.
Bool | isNFSMounted () const
| Check if a directory is mounted via NFS or not.
Public Member Functions inherited from casacore::File
| File ()
| Construct a File object whose Path is set to the current working directory.
| File (const Path &path)
| Construct a File object whose Path is set to the given Path.
| File (const String &path)
| File (const File &that)
| Copy constructor (copy semantics).
virtual | ~File ()
File & | operator= (const File &that)
| Assignment (copy semantics).
const Path & | path () const
| Returns the pathname of the file.
Bool | isRegular (Bool followSymLink=True) const
| Check if the file is a regular file.
Bool | isDirectory (Bool followSymLink=True) const
| Check if the file is a directory.
Bool | isSymLink () const
| Check if the file is a symbolic link.
Bool | isPipe () const
| Check if the file is a pipe.
Bool | isCharacterSpecial () const
| Check if the file is a character special file.
Bool | isBlockSpecial () const
| Check if the file is a block special file.
Bool | isSocket () const
| Check if the file is a socket.
Bool | exists () const
| Check if the file exists.
Bool | isReadable () const
| Check if the file is readable.
Bool | isWritable () const
| Check if the file is writable.
Bool | isExecutable () const
| Check if the file is executable.
Bool | canCreate () const
| Check if a file can be created.
long | userID () const
| Return the userID of the file.
long | groupID () const
| Return the groupID of the file.
uInt | readPermissions () const
| Return the permissions as a decimal value.
void | setPermissions (uInt permissions)
| Set permission with perm.
void | touch (uInt time)
| Update access time and modification time of a file.
void | touch ()
| Update access time and modification time of a file.
uInt | accessTime () const
| Time related fucnctions: Return the time when the file was last accessed in seconds since 00:00:00 GMT Jan 1, 1970.
String | accessTimeString () const
| Return the time when the file was last accessed as a 26-characters String of the form: Thu Feb 3 13:40:11 1994.
uInt | modifyTime () const
| Return the time when the file was last modified in seconds since 00:00:00 GMT Jan 1, 1970.
String | modifyTimeString () const
| Return the time when the file was last modified as a 26-characters String of the form: Thu Feb 3 13:40:11 1994.
uInt | statusChangeTime () const
| Return the time when the file status was last changed in seconds since 00:00:00 GMT Jan 1, 1970.
String | statusChangeTimeString () const
| return the time when the file status was last changed as a 26-characters String of the form: Thu Feb 3 13:40:11 1994
FileWriteStatus | getWriteStatus () const
| get write status of the file.
String | getFSType () const
| Return the filesystem type.

## Static Public Member Functions

static Vector< String > | shellExpand (const Vector< String > &files, Bool stripPath=False)
| For each element of files, find all file names matching it using shell file-expansion rules.
Static Public Member Functions inherited from casacore::File
static Path | newUniqueName (const String &directory, const String &prefix)
| Create a new unique path name in the specified directory, with the specified prefix and random trailing characters:
static Path | newUniqueName (const String &directory)
| Create a new unique filename without a prefix.

## Private Member Functions

void | checkPath ()
| Check if the path defines a directory.

## Private Attributes

File | itsFile
| This variable is used when a symbolic link is given to be a directory.

## Additional Inherited Members

Public Types inherited from casacore::File
enum | FileWriteStatus { OVERWRITABLE , NOT_OVERWRITABLE , CREATABLE , NOT_CREATABLE }
Protected Member Functions inherited from casacore::File
void | removeSymLinks ()
| This function is used by RegularFile and Directory to remove all the links which, when followed, ultimately resolve to a Directory or a RegularFile.
void | checkTarget (Path &targetName, Bool overwrite, Bool forDirectory=False) const
| Check if the new path for a copy or move is valid.

## Detailed Description

Get information about, and manipulate directories

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Intended use:

Public interface

### Prerequisite

- Basic knowledge of the UNIX file system
- File

### Synopsis

Directory provides functions to manipulate and to get information about directories. The functions for getting information (like ownership, dates) about directories are inherited from the File class. Directory itself provides functions to create, copy, move, or remove a directory. The file name can be a symbolic link resolving (eventually) to a directory.

A separate class DirectoryIterator allows one to traverse a directory to get the file names in it.

### Example

Directory dir("someDir");
// Create directory someDir in the working directory.
dir.create();
cout << dir.nEntries(); // \#entries
// Assign to another directory.
dir = Directory("otherDir");
// Remove the directory and its contents.
dir.removeRecursive();
casacore::Directory::Directory
Directory()
Sets the path on the current working directory.

### Motivation

Provide functions for manipulating and getting information about directories.

Definition at line 85 of file Directory.h.

## Constructor & Destructor Documentation

## Directory() [1/5]

casacore::Directory::Directory | ( |  | ) |

Sets the path on the current working directory.

Referenced by Directory(), and operator=().

## Directory() [2/5]

casacore::Directory::Directory | ( | const Path & | name | ) |

Create a directory object for a file with the given path name.

An exception is thrown if the directory is illegal, i.e. if it does not exist as a directory or symbolic link or if cannot be created. Note that the directory is not created if it does not exist yet. This can be done using the function create.
When the given path name is a symbolic link, the symbolic link is resolved (recursively) and the resulting directory name is used instead.

References casacore::name().

## Directory() [3/5]

casacore::Directory::Directory | ( | const String & | name | ) |

References casacore::name().

## Directory() [4/5]

casacore::Directory::Directory | ( | const File & | name | ) |

References casacore::File::File(), and casacore::name().

## Directory() [5/5]

casacore::Directory::Directory | ( | const Directory & | that | ) |

Copy constructor (copy semantics).

References Directory().

## ~Directory()

casacore::Directory::~Directory | ( |  | ) |

## Member Function Documentation

## checkPath()

void casacore::Directory::checkPath | ( |  | ) |

private

Check if the path defines a directory.

Also resolve possible symlinks.

## copy() [1/2]

void casacore::Directory::copy | ( | const Path & | target,
|  | Bool | overwrite = True,
|  | Bool | setUserWritePermission = True ) const

Copy the directory and its contents (recursively) to the target path using the system command cp -r.

If the target already exists (as a file, directory or symlink), and overwrite=True, it will first be removed. The target directory is created and the data in the source directory is copied to the new directory.
An exception is thrown if:
- the target directory is not writable
- or the target already exists and overwrite!=True
Caution: 1; The behavior of this copy function is different from cp when the target directory already exists; Cp copies the source to a subdirectory of the target, while copy recreates the target;
2; When a readonly file is copied, cp the resulting file is also readonly; Therefore chmod is used to set user write permission after the copy; The flag setUserWritePermission can be set to False when that should not be done;

References casacore::True.

Referenced by copy().

## copy() [2/2]

void casacore::Directory::copy | ( | const String & | target,
|  | Bool | overwrite = True,
|  | Bool | setUserWritePermission = True ) const

inline

Definition at line 240 of file Directory.h.

References copy().

## copyRecursive()

void casacore::Directory::copyRecursive | ( | const String & | target | ) | const

Copy a directory recursively in a manual way.

This is used in a copy using the system command is not possible (like on the Cray XT3).

## create()

void casacore::Directory::create | ( | Bool | overwrite = True | ) |

Create the directory.

If the directory exists and overwrite=True, it will be removed (recursively). Otherwise an exception is thrown.

References casacore::True.

## find()

Vector< String > casacore::Directory::find | ( | const Regex & | regexp,
|  | Bool | followSymLinks = False,
|  | Bool | recursive = True ) const

Find all files which whose names match regex.

You can do this recursively (default) or not. Note that the matching is a regular expression match, not a shell file-expansion match. However, a shell file pattern can be converted to a regexp using the function Regex::fromPattern. Regex::fromString allows one to convert a file name to a regexp and to use this function for eact file name matching.
To match the semantics of the unix find command, symbolic links are not followed by default, but this behavior can be over-ridden.

References casacore::False, and casacore::True.

## freeSpace()

Double casacore::Directory::freeSpace | ( |  | ) | const

Get the amount of free space (in bytes) on the file system this directory is on.

When the directory path is a symbolic link, that link is resolved first.

Referenced by freeSpaceInMB().

## freeSpaceInMB()

uInt casacore::Directory::freeSpaceInMB | ( |  | ) | const

inline

Definition at line 249 of file Directory.h.

References freeSpace().

## isEmpty()

Bool casacore::Directory::isEmpty | ( |  | ) | const

Check if directory is empty.

If the directory does not exist, an exception will be thrown.

## isNFSMounted()

Bool casacore::Directory::isNFSMounted | ( |  | ) | const

Check if a directory is mounted via NFS or not.

## move() [1/2]

void casacore::Directory::move | ( | const Path & | target,
|  | Bool | overwrite = True )

Move the directory to the target path using the system command mv.

If the target already exists (as a file, directory or symlink), and overwrite=True, it will first be removed. The source directory is moved (thus renamed) to the target.
An exception is thrown if:
- the target directory is not writable
- or the target already exists and overwrite!=True
Caution: The behavior of this move function is different from mv when the target directory already exists; Mv moves the source to a subdirectory of the target, while move recreates the target;

References casacore::True.

Referenced by move().

## move() [2/2]

void casacore::Directory::move | ( | const String & | target,
|  | Bool | overwrite = True )

inline

Definition at line 245 of file Directory.h.

References move().

## nEntries()

uInt casacore::Directory::nEntries | ( |  | ) | const

Return the number of entries in the directory (not counting.

and..). If the directory does not exist, an exception will be thrown.

## operator=()

Directory & casacore::Directory::operator= | ( | const Directory & | that | ) |

Assignment (copy semantics).

References Directory().

## remove()

void casacore::Directory::remove | ( |  | ) |

Remove a directory.

An exception is thrown if the directory is not empty. If a symbolic link is given, the link chain pointing to the directory will also be removed.

## removeFiles()

void casacore::Directory::removeFiles | ( |  | ) |

Remove all files in the directory except subdirectories.

The directory itself is not removed.

## removeRecursive()

void casacore::Directory::removeRecursive | ( | Bool | keepDir = False | ) |

Remove the directory and its contents (recursively in all subdirectories).

If keepDir==True, the directory itself is kept (to keep properties like placement on Lustre).

References casacore::False.

## shellExpand()

Vector< String > casacore::Directory::shellExpand | ( | const Vector< String > & | files,
|  | Bool | stripPath = False )

static

For each element of files, find all file names matching it using shell file-expansion rules.

Return the list of all matched files as absolute path + file names. You may optionally drop the path and just return the file names. Note tha if files(i) contains a path as well as a file name, no matching is done on the path, just the trailing file name. Throws an AipsError if the shell pattern is illegal.

References casacore::False.

## size()

virtual Int64 casacore::Directory::size | ( |  | ) | const

virtual

Return the total size of everything in the Directory.

If the Directory does not exist, an exception will be thrown.

Reimplemented from casacore::File.

## Member Data Documentation

## itsFile

File casacore::Directory::itsFile

private

This variable is used when a symbolic link is given to be a directory.

Definition at line 235 of file Directory.h.

The documentation for this class was generated from the following file:

- casa/OS/Directory.h